#include "share.h"
#include <bass.h>
#pragma comment(lib,"bass.lib")

class THIBASS_ChannelFX_Eq:public TDebug
{
   private:
    HFX fx;
    
   public:
      int _prop_Center;
      int _prop_Bandwidth;
      int _prop_Gain;  
     THI_Event *_data_Channel;
     THI_Event *_data_Center;
     THI_Event *_data_Bandwidth;
     THI_Event *_data_Gain;	 	 	  
     THI_Event *_event_onSet;
     
    HI_WORK_LOC(THIBASS_ChannelFX_Eq,_work_doSet)
    { 
      BASS_DX8_PARAMEQ p;
	   BASS_FXGetParameters(fx,&p);
            p.fGain = 10.0-(ReadInteger(_Data, _data_Gain, _prop_Gain));
            BASS_FXSetParameters(fx,&p); 
            _hi_onEvent(_event_onSet);
    }

    HI_WORK_LOC(THIBASS_ChannelFX_Eq,_work_doUpdateFX)
    {
       BASS_PluginLoad("bass_fx.dll", 0);
          int chan = ReadInteger(_Data, _data_Channel,0);  
           BASS_ChannelRemoveFX(chan,fx); 
             BASS_DX8_PARAMEQ p;
	        fx=BASS_ChannelSetFX(chan, BASS_FX_DX8_PARAMEQ,0); 
	            if(fx==0)MessageBox(NULL,L"Handle FX fault!",L"Error",MB_OK);
			p.fCenter = ReadInteger(_Data, _data_Center, _prop_Center);
            p.fBandwidth = ReadInteger(_Data, _data_Bandwidth, _prop_Bandwidth); 
            p.fGain = 0;
            BASS_FXSetParameters(fx,&p); 
	   TData qt;
       _work_doSet(qt,0);
    }
      
};

///////////////////////////////////////////////////////////////////////